module Pflichtuebung_01.Date exposing (..)

type alias Day =
    Int

type alias Month =
    Int

type alias Year =
    Int

type alias Date =
    ( Day, Month, Year )


-- 1 Punkt:
year : Date -> Year
year (_, _, c) = c
month : Date -> Month
month (_, b, _) = b
day : Date -> Day
day (a, _, _) = a

-- 1 Punkt:
lt : Date -> Date -> Bool
lt date1 date2 =
    let (d1, m1, y1) = date1
        (d2, m2, y2) = date2
    in y1 < y2 || (y1 == y2 && (m1 < m2 || (m1 == m2 && d1 < d2)))
eq : Date -> Date -> Bool
eq date1 date2 =
    let (d1, m1, y1) = date1
        (d2, m2, y2) = date2
    in y1 == y2 && m1 == m2 && d1 == d2
gt : Date -> Date -> Bool
gt date1 date2 =
    let (d1, m1, y1) = date1
        (d2, m2, y2) = date2
    in y1 > y2 || (y1 == y2 && (m1 > m2 || (m1 == m2 && d1 > d2)))

-- 1 Punkt:
toString : Date -> String
toString (a,b,c) = (if a < 10 then "0" ++ String.fromInt(a) else String.fromInt(a))
                    ++ (if b < 10 then "0" ++ String.fromInt(b) else String.fromInt(b))
                    ++ (if c < 10 then  "000" ++ String.fromInt(c)
                    else if c < 100 then  "00" ++ String.fromInt(c)
                    else if   c < 1000 then  "0" ++ String.fromInt(c)
                    else String.fromInt(c))
-- TT.MM.YYYY


-- 2 Punkte:
next : Date -> Date
next date = (1, 1, 1)

-- 2 Punkte:
prev : Date -> Date
prev date = (1, 1, 1)

-- 1 Punkt:
leapyear : Year -> Bool
leapyear y = False

-- 2 Punkte:
sub : Date -> Date -> Int
sub date1 date2 = 0
